// ObjectWindows - (C) Copyright 1992 by Borland International
// File: HELLOAPP.CPP

/* This modified OWL example demonstrates allocating beyond 
   64K and inspecting on values in the string beyond the
   64K selector boundary ( if huge pointers are being used the
   pointer ( essentially selector+offset, in Windows ) should
   increment correctly over the segment boundary ). Two methods
   of allocating are demonstrated using 'new' and 'farmalloc'
   Note that in Windows all huge pointers are fast huge pointers
   ( -h switch, referenced in BC++ 3.1 Users Guide page 157 ) and
   that there are issues relating to structure size when allocating
   arrays of structures that may cross segment boundaries
   ( structure size should be a power of two )
   This example built wiht large memory model
*/
#include <owl.h>
#include <bbutton.h>
#include <bwcc.h>
#include <string.h>
#include <alloc.h>
char huge* chptr; // pointer to huge array
char huge *iptr; // index to point beyond 64K
class TMyWindow: public TWindow
{
 public:
 TMyWindow( PTWindowsObject AParent, LPSTR ATitle );
 virtual void SetupWindow()
 {
   char message[128];
   TWindow::SetupWindow();
   // test the string...
   MessageBox(HWindow, (char*)iptr, "String value...", MB_OK );
                                          }
} ;

TMyWindow::TMyWindow( PTWindowsObject AParent, LPSTR ATitle ):
       TWindow( AParent, ATitle )
 {
//  chptr = new huge char[100000L]; // alocate 100000
//  or...
  chptr = (char huge*)farmalloc(1000000L);
  iptr = chptr+70000L;
  strcpy( iptr, "hello" );



  } // set breakpoint here and inspect on 'iptr' or chptr+70000L


// Define a class derived from TApplication
class THelloApp :public TApplication
{
public:
  THelloApp(LPSTR AName, HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
    : TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow) {};
  virtual void InitMainWindow();
};


// Construct the THelloApp's MainWindow data member
void THelloApp::InitMainWindow()
{
  MainWindow = new TMyWindow(NULL, "Hello World!");
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  THelloApp HelloApp ("HelloApp", hInstance, hPrevInstance,
    lpCmdLine, nCmdShow);
  HelloApp.Run();
  return HelloApp.Status;
}

